#!/bin/bash
BASEDIR=$(dirname $0)
echo searching for Info.plist to update...

function update_file
{
    if [ -f $1.tmp ]; then
        rm -f $1.tmp
    fi
	$BASEDIR/update_ifd_ccid_bundle.sh "$1" "$2" "$3" "$4" > "$1.tmp"
    rm -f "$1"
    mv "$1.tmp" "$1"
}

for file in $(find /usr/lib* /usr/local -name "Info.plist" | grep "ifd-ccid.bundle/Contents" ); do
	NOW=$(date +%d-%m-%y-%T)
	# Get source file if @Info.plist - symbolic link
	file=`readlink -e $file`
	if [ "$?" -eq 1 ]; then
		continue
	fi

	cp -f ${file} ${file}.$NOW.backup
	echo checking $file
	$BASEDIR/check_plist_integrity.sh ${file}
	if [ "$?" -eq 1 ]; then
		exit 1
	fi
	cp -f ${file} ${file}.orig
	WORK_FILE=${file}.orig
	echo updating $file
	$BASEDIR/remove_by_friendly_name.sh '<string>.*ARDS.*</string>' "$WORK_FILE"
	$BASEDIR/remove_by_friendly_name.sh '<string>.*Aladdin R.D.*</string>' "$WORK_FILE"
	$BASEDIR/remove_by_friendly_name.sh '<string>.*JaCarta.*</string>' "$WORK_FILE"
	$BASEDIR/remove_by_friendly_name.sh '<string>.*JCR-770.*</string>' "$WORK_FILE"
	$BASEDIR/remove_by_friendly_name.sh '<string>.*bR301.*</string>' "$WORK_FILE"
	$BASEDIR/remove_by_friendly_name.sh '<string>.*iR301.*</string>' "$WORK_FILE"
	$BASEDIR/remove_by_friendly_name.sh '<string>.*ASEDrive III.*</string>' "$WORK_FILE"

	update_file "$WORK_FILE" "0x24DC" "0x0101" "Aladdin R.D. JaCarta"
	update_file "$WORK_FILE" "0x24DC" "0x0102" "Aladdin R.D. JaCarta LT"
	update_file "$WORK_FILE" "0x24DC" "0x0201" "Aladdin R.D. JCR-770"
	update_file "$WORK_FILE" "0x24DC" "0x0401" "Aladdin R.D. JC-WebPass (JC600)"
	update_file "$WORK_FILE" "0x24DC" "0x0402" "Aladdin R.D. JaCarta"
	update_file "$WORK_FILE" "0x24DC" "0x0406" "Aladdin JaCarta SF GOST"
	update_file "$WORK_FILE" "0x24DC" "0x0407" "Aladdin R.D.JaCarta U2F/WebPass(JC603)"
	update_file "$WORK_FILE" "0x24DC" "0x0409" "Aladdin JaCarta SF GOST"
	update_file "$WORK_FILE" "0x24DC" "0x040A" "Aladdin JaCarta SF GOST"
	update_file "$WORK_FILE" "0x24DC" "0x040B" "Aladdin JaCarta SF GOST"
	update_file "$WORK_FILE" "0x24DC" "0x040C" "Aladdin JaCarta SF GOST"
	update_file "$WORK_FILE" "0x24DC" "0x040D" "Aladdin JaCarta SF GOST"
	update_file "$WORK_FILE" "0x24DC" "0x0420" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x0421" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x0422" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x0423" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x0424" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x0425" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x0426" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x0427" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x0428" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x0429" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x042A" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x042B" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x042C" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x042D" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x042E" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x042F" "Aladdin R.D. JaCarta 3"
	update_file "$WORK_FILE" "0x24DC" "0x04FF" "Aladdin JaCarta SF GOST"
	update_file "$WORK_FILE" "0x24DC" "0x0501" "Aladdin R.D. JaCarta U2F (JC602)"
	update_file "$WORK_FILE" "0x24DC" "0x100F" "Aladdin R.D. JaCarta Flash"
	update_file "$WORK_FILE" "0x0529" "0x0600" "Aladdin R.D. JaCarta Anywhere"
	update_file "$WORK_FILE" "0x0530" "0x0700" "Aladdin R.D. NG-OTP 72k"
	update_file "$WORK_FILE" "0x096e" "0x061A" "bR301"
	update_file "$WORK_FILE" "0x096e" "0x061C" "iR301"
	update_file "$WORK_FILE" "0x096e" "0x0619" "iR301"
	update_file "$WORK_FILE" "0x0DC3" "0x1004" "ASEDrive III USB V2C"
	update_file "$WORK_FILE" "0x0DC3" "0x0802" "ASEDrive IIIe USB"
	update_file "$WORK_FILE" "0x0DC3" "0x1104" "ASEDrive IIIe KB"
	update_file "$WORK_FILE" "0x03F0" "0x0036" "HP Model KU0133"
	
	echo checking updated $file
	$BASEDIR/check_plist_integrity.sh "$WORK_FILE"
	if [ "$?" -eq 1 ]; then
        rm -f "$WORK_FILE"
		exit 1
	fi
	
	chown --reference=${file} "$WORK_FILE"
	chmod --reference=${file} "$WORK_FILE"
	rm -f ${file}
    mv "$WORK_FILE" ${file}
done
