 /*
 * Copyright(C) 2000  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

#include "ric_prj.h"

DWORD ric_login( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{
    TReaderInfoLoginAscii *inf = (TReaderInfoLoginAscii*)info;
    TRICContext *ctx = (TRICContext*)context;
    DWORD code;
    char passwd[PIN_LENGTH + 1];

    SUPSYS_PRE_CONTEXT( context, TRICContext );
    SUPSYS_PRE_INFO( info, TReaderInfoLoginAscii);
    
    if (inf->passwd.length > PIN_LENGTH) {
	return (DWORD)SCARD_E_INVALID_CHV;
    }
    if (inf->passwd.length > 0) {
	SUPSYS_PRE(inf->passwd.text != NULL);
	SUPSYS_PRE(inf->passwd.length == strlen(inf->passwd.text));
	strcpy((char*)passwd, inf->passwd.text);
	if (inf->passwd.length < PIN_LENGTH)
	    memset(passwd + inf->passwd.length, 0x31, PIN_LENGTH - inf->passwd.length);
    }
    else {
	memset(passwd, 0x31, PIN_LENGTH);
    }
    code = ric_verify_pin( ctx, passwd, &( inf->retries ) );
    support_zero_memory(passwd, PIN_LENGTH);
    if( code ) 
	return code;
    ctx->status = RIC_STATUS_PIN_VERIFIED;
    return ERROR_SUCCESS;
}

/* end of file: $Id: ric_log.c 186620 2018-12-24 13:38:12Z borodin $ */
